"use strict";
var car = new L.Icon({
  iconUrl: "topViewCarro.svg",
  iconSize: [16, 31],
  iconAnchor: [6, 22],
});
var markersContainer = L.markerClusterGroup({
  showCoverageOnHover: false,
  removeOutsideVisibleBounds: false,
  disableClusteringAtZoom: 11,
  maxClusterRadius: 30,
});

var storage = window.localStorage;
var nofollow = false;
var isClusteringEnabled = false;
var lastgetpoionlat;
var lastgetpoionlng;
var lastgetobjectslat;
var lastgetobjectslng;
var updated = false;
var markers = new Array();
var members = new Array();
var objects = new Array();
var objectViewCache = new Array();
var alerts = {};
var objRepo;
var poi = {};
var zones = new Array();
var zonesbadges = new Array();
var lastResult = [];
var zoneClick = false;
var selfZoom = false;
var map = L.map("map", {
  renderer: L.svg(),
  zoomControl: false,
  zoomSnap: 0.1,
});
var resumed = true;
var curgid;
var mapready = false;
var fadeWorking = {};
var vectorLayer = "local";
var isNightTheme = false;
var isStopped = false;
var newCenterListennerEnabled = false;
var smoothMovers = {};
var solitaryBearing = 90;
var solitaryUpdater;
var solitaryLoc = [0, 0, 0];
var solitaryModeOn = false;
var ready = false;
var isMoving = false;
var canvasLayer;
var distances = [];
var heatRadius = 5;
map.on("click", function () {
  if (isFollowing == true || isPOISelected == true || zoneClick == true) {
    isFollowing = false;
    isPOISelected = false;
    zoneClick = false;
    selectedMarker = "unset";
    app.mapNeedsToCenter();
    //map.setView(new L.LatLng(centerLat, centerLng),11, {animation: true});
    app.mapClicked();
  }
});
map.on("zoomend", function () {
  nofollow = false;
  app.onMapZoomChange(map.getZoom());
  markersTimer(true);
  isMoving = false;
});
map.on("zoomstart", function () {
  nofollow = true;
  markersTimer(false);
  isMoving = true;
});
map.on("movestart", function () {
  markersTimer(false);
  isMoving = true;
});
map.on("moveend", function () {
  markersTimer(true);
  isMoving = false;
});
map.on("zoomend moveend", function () {
  isMoving = false;
  nofollow = false;
  if (newCenterListennerEnabled == true) {
    let mapCenter = map.getCenter();
    console.log("latitude: " + mapCenter.lat + " longitude: " + mapCenter.lng);
    app.mapNewCenter(mapCenter.lat, mapCenter.lng);
  }
  if (!isFollowing == true || !isPOISelected == true || !zoneClick == true) {
    if (selfZoom == false && changingGroup == false) {
      app.mapMovementDetected();
    } else {
      setTimeout(function () {
        selfZoom = false;
      }, 500);
    }
  }
});

/*map.on('move', function() {
    clearTimeout(getpoisontimer);
    var getpoisontimer = setTimeout(getPOIsON, 400);
});*/
var markersLayer = {};
var poiLayer = {};
var objectsLayer = {};
var getpoisontimer;
var getobjectstimer;
var isPOISelected = false;
var selectedMarker = "unset";
var centerLat;
var centerLng;
var sessionKey = "unset";
var remoteServerUrl = "https://server.drivesocial.io/DSAPI/api19.php";
var isMarkersBusy = false;
var markersUpdater;
var membersUpdater;
var visibilityUpdater;
var followHelper;
var isFollowing = false;
var gid = "unset";
var markerWaiting = new Array();
var isPOIEnabled = false;
var pendingMarkers = new Array();
var changingGroup = false;
var criticalZonesEnabled = true;
var lastResult2;
var czLayer = L.layerGroup().addTo(map);
var heatEnabled = false;
var heatLayer = null;
var heatData;
var heatUpdateTimer;
function DSEnableNewCenterEvent() {
  newCenterListennerEnabled = true;
}
function DSSetSession(sess) {
  //console.log("setting sessionKey to " + sess);
  sessionKey = sess;
  //getMembers(true);

  if (criticalZonesEnabled == true) {
    setTimeout(getCriticalZones, 2000);
  }
}
function addToLayer(id) {
  if (typeof markersLayer[id] == "undefined" || markersLayer[id] == null) {
    markersLayer[id] = true;
    //map.addLayer(markers[id]);
    //console.log("added: " + id);
    if (!map.getBounds().contains(markers[id])) {
      map.removeLayer(markers[id]);
      delete markersLayer[id];
    }
  }
}
function removeFromLayer(id) {
  if (typeof markersLayer[id] != "undefined" || markersLayer[id] != null) {
    delete markersLayer[id];
    //map.removeLayer(markers[id]);
  }
}
function isAdded(id) {
  if (markersLayer[id]) {
    return true;
  } else {
    return false;
  }
}
function setMap(name) {
  document.title = name;
}
function DSEnableClustering(args) {
  if (args == "true") {
    map.addLayer(markersContainer);
    isClusteringEnabled = true;
  } else {
    isClusteringEnabled = false;
  }
}
function DSSetHeatmapRadius(radius) {
  heatRadius = radius;
}
function setHeatTimer() {
  if (heatUpdateTimer != null) {
    clearInterval(heatUpdateTimer);
  }
  heatUpdateTimer = setInterval(function () {
    xhr("getHeatData", heatRadius, function (data) {
      displayHeatData(data);
    });
  }, 3000);
  xhr("getHeatData", heatRadius, function (data) {
    displayHeatData(data);
  });
}
function DSEnableHeatMap() {
  heatEnabled = true;
  map.setMinZoom(10);
  map.setMaxZoom(13);
  setHeatTimer();
}
function getPreferredRadius(presences) {
  let accumulator = 0;
  let presenceCount = 0;
  let lastLat = null;
  let lastLong = null;
  for (let i = 0; i <= Object.keys(presences).length - 1; i++) {
    let object = presences[i];
    if (lastLat == null && lastLong == null) {
      lastLat = object[0];
      lastLong = object[1];
    } else {
      let dist = distance(lastLat, lastLong, object[0], object[1]);

      lastLat = object[0];
      lastLong = object[1];
      if (dist >= 10 && dist <= 40) {
        accumulator = accumulator + dist;
        presenceCount++;
      }
    }
  }
  let average = accumulator / presenceCount;
  distances.push(average);
  let avgAccumulator = 0;
  for (let o = 0; o <= Object.keys(distances).length - 1; o++) {
    avgAccumulator = avgAccumulator + distances[o];
  }
  let accAverage = avgAccumulator / Object.keys(distances).length;
  console.log("average dist: " + accAverage);
  return accAverage;
}
function displayHeatData(dt) {
  let data = JSON.parse(dt);
  let preferredRadius = getPreferredRadius(data.presences);
  let options = {
    radius: preferredRadius,
    max: 13,
    gradient: {
      0.1: "#0039e6",
      0.2: "#0033cc",
      0.3: "#002db3",
      0.4: "#002699",
      0.5: "#ff9933",
      0.6: "#ff471a",
      0.7: "#cc2900",
      0.8: "#b32400",
      0.9: "#991f00",
      1: "#802000",
    },
  };
  if (data.result === "true") {
    if (heatEnabled && heatLayer == null) {
      heatLayer = L.heatLayer(data.presences, options).addTo(map);
    } else if (heatEnabled && heatLayer != null) {
      map.removeLayer(heatLayer);
      heatLayer = L.heatLayer(data.presences, options).addTo(map);
    }
    if (typeof app.extrasReceiver === "function") {
      app.extrasReceiver(
        JSON.stringify({ nearbyCount: data.presences.length })
      );
    }
  }
}
function DSEnableCriticalZones(args) {
  if (args == "true") {
    criticalZonesEnabled = true;
  } else {
    criticalZonesEnabled = false;
  }
}
function DSEnablePOI(arg) {
  ////console.log("POI: " + arg)
  if (arg == "true") {
    isPOIEnabled = true;
  } else {
    isPOIEnabled = false;
  }
  clearPOIs();
}
function removePOI(pid) {
  if (typeof poi[pid] != "undefined") {
    DSFadeEffect(poi[pid], 1.0, 0.0, 420, pid, function (pid) {
      if (typeof poi[pid] != "undefined") {
        map.removeLayer(poi[pid]);
        delete poi[pid];
      }
    });
  }
}
function clearAlerts() {
  for (let key in alerts) {
    try {
      map.removeLayer(alerts[key]);
      delete alerts[key];
    } catch (error) {
      console.log("DSMapCore Exception Caugth: " + error);
    }
  }
}
function clearPOIs() {
  for (var key in poi) {
    ////console.log(poi[key]);
    DSFadeEffect(poi[key], 1.0, 0.0, 420, key, function (key) {
      if (typeof poi[key] != "undefined") {
        map.removeLayer(poi[key]);
        delete poi[key];
      }
    });
  }
}
function follower() {
  if (
    isFollowing == true &&
    selectedMarker != "unset" &&
    markers[selectedMarker] &&
    nofollow == false
  ) {
    var latLng = markers[selectedMarker].getLatLng();
    DSSetMapCenterZoom(latLng.lat, latLng.lng, map.getZoom(), true);
  }
}
function DSMapToCenter() {
  selfZoom = true;
  //map.setView(new L.LatLng(centerLat, centerLng),13, {animation: true});
  map.flyTo([centerLat, centerLng], 13, {
    animate: true,
    duration: 1,
  });
}
function DSStopFollow() {
  isFollowing = false;
  selectedMarker = "unset";
  DSMapFlyTo(centerLat, centerLng, 12, 1);
}
function DSStartFollow(MarkerLabel) {
  console.log("Looking for " + MarkerLabel);
  try {
    isFollowing = true;
    selectedMarker = MarkerLabel;
    app.userPickupStart();
    if (markers[selectedMarker]) {
      ////console.log(selectedMarker + " found.");
      var marker = markers[selectedMarker];
      var latLng = marker.getLatLng();
      DSMapFlyTo(latLng.lat, latLng.lng, 17, 1);
      app.userPickedUp();
      app.userMarkerClicked(
        MarkerLabel,
        members[MarkerLabel].fullname,
        members[MarkerLabel].avatarHash,
        latLng.lat,
        latLng.lng
      );
    } else {
      if (selectedMarker == "unset") {
        return;
      }
      // //console.log(selectedMarker + " not found yet.");
      var searchTimer = setInterval(function () {
        if (selectedMarker == "unset") {
          clearInterval(searchTimer);
          return;
        }
        //   //console.log("Another attempt - Looking for: " + selectedMarker);
        if (markers[selectedMarker]) {
          var marker = markers[selectedMarker];
          var latLng = marker.getLatLng();
          DSMapFlyTo(latLng.lat, latLng.lng, 17, 1);
          app.userPickedUp();
          app.userMarkerClicked(
            MarkerLabel,
            members[selectedMarker].fullname,
            members[MarkerLabel].avatarHash,
            latLng.lat,
            latLng.lng
          );
          //   //console.log(selectedMarker + " found.");
          clearInterval(searchTimer);
        }
      }, 500);
    }
  } catch (err) {
    console.log(`runtime error: ${err}. Will try again later.`);
    setTimeout(function () {
      DSStartFollow(MarkerLabel);
    }, 500);
  }
}
function DSNewMarker(
  MarkerLabel,
  LatLng,
  MarkerOptions,
  MarkerType,
  PopupContent,
  MarkerColor,
  Vehicle,
  massCreate
) {
  if (markers[MarkerLabel]) {
    //console.log("Marker already exists");
  } else {
    markers[MarkerLabel] = new L.Marker(LatLng, MarkerOptions);
    markers[MarkerLabel].vehicle = Vehicle;
    markers[MarkerLabel].on("click", function (marker) {
      isFollowing = true;
      selectedMarker = MarkerLabel;
      DSMapFlyTo(marker.latlng.lat, marker.latlng.lng, 17, 1);
      app.userMarkerClicked(
        MarkerLabel,
        members[MarkerLabel].fullname,
        members[MarkerLabel].avatarHash,
        marker.latlng.lat,
        marker.latlng.lng
      );
    });
    markers[MarkerLabel].setOpacity(0.0);
    try {
      if (map.getBounds().contains(LatLng)) {
        if (!isClusteringEnabled) {
          //  map.addLayer(markers[MarkerLabel]);
        } else {
          // markersContainer.addLayer(markers[MarkerLabel]);
        }
        markers[MarkerLabel].setOpacity(0.0);

        // canvasLayer.addMarker(markers[MarkerLabel]);
      }
    } catch (err) {
      //console.log("Ignoring map bounds due to error: " + err);
      //canvasLayer.addMarker(markers[MarkerLabel]);
      if (!isClusteringEnabled) {
        // map.addLayer(markers[MarkerLabel]);
      } else {
        //markersContainer.addLayer(markers[MarkerLabel]);
      }
      markers[MarkerLabel].setOpacity(0.0);
    }
    //addToLayer(MarkerLabel);
    if (typeof massCreate == "undefined" || !massCreate) {
      app.requestMarkerIcon(MarkerLabel, MarkerColor, Vehicle);
    } else {
      return { label: MarkerLabel, color: MarkerColor, vehicle: Vehicle };
    }
  }
}
function DSMassDeploy(payload) {
  const array = JSON.parse(payload);
  array.map(function (obj) {
    DSDeployMarkerIcon(
      obj.label,
      obj.path,
      obj.arrow,
      obj.dimension0,
      obj.dimension1
    );
  });
  /*for (let i = 0; i <= array.length - 1; i++) {
    let obj = array[i];
    DSDeployMarkerIcon(
      obj.label,
      obj.path,
      obj.arrow,
      obj.dimension0,
      obj.dimension1
    );*/
  clearInterval(visibilityUpdater);
  checkVisibility();
  visibilityUpdater = setInterval(function () {
    checkVisibility();
  }, 500);
}
function DSDeployMarkerIcon(MarkerLabel, IconPath, ArrowIcon, Width, Height) {
  let anchor = [0, 0];
  anchor[0] = Math.abs(Width / 2);
  anchor[1] = Math.abs(Height / 2);
  if (markers[MarkerLabel] && markers[MarkerLabel] != null) {
    var marker = markers[MarkerLabel];
    ////console.log("Label: " + MarkerLabel + ", IconPath: " + IconPath);

    if (ArrowIcon == "false" || ArrowIcon == false) {
      marker.setIcon(
        new L.Icon({
          iconUrl: IconPath,
          iconSize: [Width, Height],
          iconAnchor: anchor,
        })
      );
      marker.setRotationOrigin("center");
      if (map.getBounds().contains(marker.getLatLng())) {
        map.addLayer(marker);
      }
    } else if (ArrowIcon == "true" || ArrowIcon == true) {
      marker.setIcon(
        new L.Icon({
          iconUrl: IconPath,
          iconSize: [Width, Height],
          iconAnchor: anchor,
        })
      );

      marker.setRotationOrigin("center");
      if (map.getBounds().contains(marker.getLatLng())) {
        map.addLayer(marker);
      }
    }
    DSFadeEffect(markers[MarkerLabel], 0.0, 1.0, 500, MarkerLabel);
  } else {
    ////console.log(MarkerLabel + ": deploy failed, will try again later");
    markerWaiting[MarkerLabel] = new Array();
    markerWaiting[MarkerLabel].IconPath = IconPath;
    markerWaiting[MarkerLabel].Count = 0;
    pendingMarkers[MarkerLabel] = setInterval(function () {
      // //console.log(MarkerLabel + ": trying - deploy...");
      if (markers[MarkerLabel]) {
        var marker = markers[MarkerLabel];
        if (ArrowIcon == "false") {
          marker.setIcon(
            new L.Icon({
              iconUrl: IconPath,
              iconSize: [Width, Height],
              iconAnchor: anchor,
            })
          );
          marker.setRotationOrigin("center");
          if (map.getBounds().contains(marker.getLatLng())) {
            map.addLayer(marker);
          }
        } else if (ArrowIcon == "true") {
          marker.setIcon(
            new L.Icon({
              iconUrl: IconPath,
              iconSize: [Width, Height],
              iconAnchor: anchor,
            })
          );
          marker.setRotationOrigin("center");
          if (map.getBounds().contains(marker.getLatLng())) {
            map.addLayer(marker);
          }
        }
        DSFadeEffect(markers[MarkerLabel], 0.0, 1.0, 500, MarkerLabel);

        //  //console.log(MarkerLabel + ": deployed.");
        if (typeof MarkerLabel != "undefined" || MarkerLabel != null) {
          if (
            typeof markerWaiting[MarkerLabel] != "undefined" ||
            markerWaiting[MarkerLabel] != null
          ) {
            if (typeof markerWaiting[MarkerLabel].IconPath != "undefined") {
              delete markerWaiting[MarkerLabel].IconPath;
            }
            delete markerWaiting[MarkerLabel];
            clearInterval(pendingMarkers[MarkerLabel]);
          }
        }
      } else {
        if (markerWaiting[MarkerLabel]) {
          markerWaiting[MarkerLabel].Count++;
          //   //console.log(MarkerLabel + ": deploy failed (trying again)");
          if (markerWaiting[MarkerLabel].Count > 20) {
            // //console.log(MarkerLabel + ": deploy failed (giving up)");
            clearInterval(pendingMarkers[MarkerLabel]);
            delete markerWaiting[MarkerLabel].IconPath;
            delete markerWaiting[MarkerLabel];
          }
        } else {
          // //console.log("label not found - cancelling pending deploy");
          clearInterval(pendingMarkers[MarkerLabel]);
        }
      }
    }, 300);
  }
}
function DSMapClear() {
  clearMapObjects();
  clearPOIs();
  clearAlerts();
  for (var key in lastResult) {
    delete lastResult[key];
  }
  for (var key in members) {
    delete members[key];
  }
  for (var key in markers) {
    var marker = markers[key];
    if (isClusteringEnabled == true) {
      markersContainer.removeLayer(marker);
    } else {
      map.removeLayer(marker);
    }
    delete markers[key];
  }
}
function checkVisibility() {
  if (!isMoving) {
    for (var key in markers) {
      if (typeof markers[key] != "undefined") {
        if (map.getBounds().contains(markers[key].getLatLng())) {
          if (!markersLayer[key]) {
            markers[key].setOpacity(0.0);
            if (!isClusteringEnabled) {
              map.addLayer(markers[key]);
            } else {
              markersContainer.addLayer(markers[key]);
            }
            //map.addLayer(markers[key]);
            DSFadeEffect(markers[key], 0.0, 1, 500, key);
            markersLayer[key] = true;
          }
        } else {
          if (markersLayer[key]) {
            DSFadeEffect(markers[key], 1, 0.0, 500, key, function (key) {
              //map.removeLayer(markers[key]);
              if (!isClusteringEnabled) {
                map.removeLayer(markers[key]);
              } else {
                markersContainer.removeLayer(markers[key]);
              }
              delete markersLayer[key];
            });
          }
        }
      }
    }
    for (var key in poi) {
      if (typeof poi[key] != "undefined") {
        if (map.getBounds().contains(poi[key].getLatLng())) {
          if (!poiLayer[key]) {
            poi[key].setOpacity(0.0);
            map.addLayer(poi[key]);
            DSFadeEffect(poi[key], 0.0, 1, 500, key);
            poiLayer[key] = true;
          }
        } else {
          if (poiLayer[key]) {
            DSFadeEffect(poi[key], 1, 0.0, 500, key, function (key) {
              try {
                map.removeLayer(poi[key]);
                delete poiLayer[key];
              } catch (error) {
                //console.log("POI error: " + error);
              }
            });
          }
        }
      }
    }
    for (var key in objects) {
      if (map.getZoom() >= 11) {
        if (typeof objects[key] != "undefined") {
          if (objFitsTheBound(objects[key])) {
            showObjOnMap(key, objects[key]);
          } else if (!objFitsTheBound(objects[key])) {
            hideObjOnMap(key, objects[key]);
          }
        }
      } else if (map.getZoom() < 11) {
        hideObjOnMap(key, objects[key]);
      }
    }
  }
}
function getObjectById(id) {
  for (var i in objRepo) {
    if (objRepo[i].id == id) {
      return objRepo[i];
    }
  }
}
function markersTimer(enabled) {
  if (enabled && typeof markersUpdater === "undefined") {
    markersUpdater = setInterval(function () {
      updateMarkers();
    }, 3200);
    updateMarkers();
  } else {
    clearInterval(markersUpdater);
    markersUpdater = undefined;
  }
}
function DSSetGroup(newgid) {
  curgid = newgid;
  changingGroup = true;
  DSMapClear();
  clearInterval(markersUpdater);
  clearInterval(membersUpdater);
  clearInterval(visibilityUpdater);
  //delete visibilityUpdater;

  gid = newgid;
  restoreMembers(curgid);
  //setTimeout(function() { getMembers(true) }, 1000);
  //setTimeout(function() { DSMapClear() }, 2000);
  getpoisontimer = setInterval(function () {
    getPOIsON();
  }, 3000);
  membersUpdater = setInterval(function () {
    getMembers();
  }, 3000);
  markersUpdater = setInterval(function () {
    updateMarkers();
  }, 3200);

  getObjects();
  getPOIsON();
  getMembers(true);
  changingGroup = false;
  //setTimeout(function() { changingGroup = false; }, 300);
}
function restoreMembers(gid) {
  if (gid != "unset") {
    setTimeout(function () {
      if (typeof storage != "undefined") {
        var gdata = storage.getItem(gid);
        // //console.log("Restoring gdata @ " + gid);
        if (typeof gdata != "undefined" && gdata != null) {
          lastResult = JSON.parse(gdata);

          updated = true;
          updateMarkers();
          //setTimeout(function() { updateMarkers(); }, 300);
        }
      }
    }, 300);
  }
}
function DSOnStop() {
  isStopped = true;
  stopPendingDeploys();
  //DSMapClear();
  clearInterval(markersUpdater);
  clearInterval(membersUpdater);
  clearInterval(visibilityUpdater);
  clearInterval(getobjectstimer);
  clearInterval(heatUpdateTimer);

  stopMovers();
  clearMovers();
  clearZones();
}
function stopMovers() {
  for (let key in smoothMovers) {
    try {
      if (
        typeof smoothMovers[key].cancel !== "undefined" &&
        typeof smoothMovers[key].cancel === "function"
      ) {
        smoothMovers[key].cancel();
      }
    } catch (err) {
      console.error(err);
    }
  }
}
function clearMovers() {
  for (let key in smoothMovers) {
    try {
      delete smoothMovers[key];
    } catch (err) {
      console.error(err);
    }
  }
}
function stopPendingDeploys() {
  if (markerWaiting) {
    for (var key in markerWaiting) {
      ////console.log(key + ": stopping pending deploy");
      clearInterval(markerWaiting[key]);
      delete markerWaiting[key];
    }
  }
}
function DSReloadMapObjects() {
  DSMapClear();
  clearPOIs();
  //getMembers(true);
  getPOIs();
  clearZones();
  if (criticalZonesEnabled == true) {
    getCriticalZones();
  }
}
function DSOnResume() {
  isStopped = false;
  resumed = true;
  if (heatEnabled) {
    setHeatTimer();
  }
  clearZones();
  if (criticalZonesEnabled == true) {
    getCriticalZones();
  }
  //DSMapClear();
  //restoreMembers(gid);
  setTimeout(getTopRankedAlerts, 600);
  if (changingGroup == false) {
    //setTimeout(function() { getMembers(true) }, 1000);
    //getMembers(true);
    getPOIs();
  }
  getMembers();
  clearInterval(membersUpdater);
  membersUpdater = setInterval(function () {
    getMembers();
  }, 3000);
  clearInterval(markersUpdater);
  markersUpdater = setInterval(function () {
    updateMarkers();
  }, 3070);
  clearInterval(visibilityUpdater);
  visibilityUpdater = setInterval(function () {
    checkVisibility();
  }, 500);
  getObjects();
  getTopRankedAlerts();
}
function DSetMyLoc(latitude, longitude) {
  centerLat = latitude;
  centerLng = longitude;
}
function DSMapFlyTo(lat, lng, zoom, duration) {
  if (typeof duration == "undefined") {
    duration = 1;
  }

  map.flyTo([lat, lng], zoom, {
    animate: true,
    duratio: duration,
  });
}

function DSAddDefaultMarker(lat, lng) {
  let typeIcon = "file:///android_asset/DSMap/images/marker-icon.png";
  ////console.log(data[key].pid + ": spawning POI (type: " + data[key].type + ", iconURL: " + typeIcon + ")");
  var defaultMarkerIcon = new L.Icon({
    iconUrl: typeIcon,
    iconSize: [25, 41],
  });
  var defaultMarker = new L.Marker(new L.LatLng(lat, lng), {
    icon: defaultMarkerIcon,
  });
  map.addLayer(defaultMarker);
}
function DSSetMapCenterZoom(lat, lng, zoom, animated) {
  console.log(
    `new map center latitude: ${lat}, longitude: ${lng}, zoom: ${zoom}`
  );
  selfZoom = true;
  /*if (solitaryModeOn == true) {
    setSolitaryLocation(lat, lng);
  }*/
  if (animated == true) {
    map.setView(new L.LatLng(lat, lng), zoom, { animation: true });
  } else {
    map.setView(new L.LatLng(lat, lng), zoom, { animation: false });
  }
}
function xhr(action, argument, callback, callbackError, async) {
  if (sessionKey == "unset") {
    //console.log("sessionkey = unset ; xhr() refuses to continue.");
    return;
  }
  if (async) {
    var asynchronous = false;
  } else {
    var asynchronous = true;
  }
  $.ajax({
    method: "GET",
    url: remoteServerUrl,
    crossDomain: true,
    timeout: 30000,
    contentType: "application/json",
    async: asynchronous,
    headers: {
      "X-Requested-With": "XMLHttpRequest",
    },
    data: {
      action: action,
      argument: argument,
      sessionkey: sessionKey,
    },
    success: function (datartrn) {
      callback(datartrn);
    },
    error: function (datartrn) {
      if (!callbackError) {
        alert("Ocorreu um erro de rede, verifique sua conexão.");
      } else {
        callbackError(datartrn);
      }
    },
  });
}
function distance(lat1, lon1, lat2, lon2) {
  var R = 6371; // km (change this constant to get miles)
  var dLat = ((lat2 - lat1) * Math.PI) / 180;
  var dLon = ((lon2 - lon1) * Math.PI) / 180;
  var a =
    Math.sin(dLat / 2) * Math.sin(dLat / 2) +
    Math.cos((lat1 * Math.PI) / 180) *
      Math.cos((lat2 * Math.PI) / 180) *
      Math.sin(dLon / 2) *
      Math.sin(dLon / 2);
  var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
  var d = R * c;
  /*if (d>1) return Math.round(d)+"km";
    else if (d<=1) return Math.round(d*1000)+"m";*/
  return Math.round(d * 1000);
}

function updateMarkers(massCreate) {
  isMarkersBusy = true;
  let massRequest = [];
  if (updated) {
    //checks for current markers and update!
    var date = new Date();
    for (var key in lastResult) {
      var item = lastResult[key];
      if (isExistentMember(item.uid)) {
        var member = getMemberInstance(item.uid);
        if (
          member.vehicle !== item.vehicle ||
          member.markerColor !== item.markerColor
        ) {
          member.vehicle = item.vehicle;
          member.markerColor = item.markerColor;
          saveMemberInstance(item.uid, member);
          console.log(
            "Color or Vehicle change detected. Updating marker. Vehicle = " +
              item.vehicle +
              ", color = " +
              item.markerColor
          );
          app.requestMarkerIcon(
            "id_" + item.uid,
            item.markerColor,
            item.vehicle
          );
        }
        if (
          item.lat != member.lat ||
          item.lng != member.lng ||
          item.bearing != member.bearing
        ) {
          if (markers["id_" + item.uid]) {
            var mrkr = markers["id_" + item.uid];
            var oldlat = mrkr.getLatLng()["lat"];
            var oldlng = mrkr.getLatLng()["lng"];
            var dist = distance(oldlat, oldlng, item.lat, item.lng);
            if (dist < 1000) {
              smoothMove(
                mrkr.getLatLng(),
                new L.LatLng(item.lat, item.lng),
                member.bearing,
                item.bearing,
                date.getTime(),
                3000,
                mrkr,
                "id_" + item.uid
              );
            } else {
              mrkr.setLatLng(new L.LatLng(item.lat, item.lng));
            }
            mrkr.setRotationAngle(item.bearing);
          } else {
            if (massCreate) {
              massRequest.push(
                DSNewMarker(
                  "id_" + item.uid,
                  new L.LatLng(item.lat, item.lng),
                  { icon: car, rotationAngle: item.bearing, opacity: 0.0 },
                  "user",
                  item.fullname,
                  item.markerColor,
                  item.vehicle,
                  true
                )
              );
            } else {
              DSNewMarker(
                "id_" + item.uid,
                new L.LatLng(item.lat, item.lng),
                { icon: car, rotationAngle: item.bearing, opacity: 0.0 },
                "user",
                item.fullname,
                item.markerColor,
                item.vehicle
              );
            }
          }
        }
      } else {
        members["id_" + item.uid] = item;
        if (massCreate) {
          massRequest.push(
            DSNewMarker(
              "id_" + item.uid,
              new L.LatLng(item.lat, item.lng),
              { icon: car, rotationAngle: item.bearing, opacity: 0.0 },
              "user",
              item.fullname,
              item.markerColor,
              item.vehicle,
              true
            )
          );
        } else {
          DSNewMarker(
            "id_" + item.uid,
            new L.LatLng(item.lat, item.lng),
            { icon: car, rotationAngle: item.bearing, opacity: 0.0 },
            "user",
            item.fullname,
            item.markerColor,
            item.vehicle
          );
        }
      }
      members["id_" + item.uid].lat = item.lat;
      members["id_" + item.uid].lng = item.lng;
      members["id_" + item.uid].bearing = item.bearing;
      var unix = Math.round(+new Date() / 1000);
      var tsResult = unix - item.lastUpdate;
      if (tsResult >= 300) {
        markers["id_" + item.uid].setOpacity(0.5);
      } else {
        markers["id_" + item.uid].setOpacity(1);
      }
    }
    for (var o in members) {
      if (typeof members[o] != "undefined") {
        if (!getResultInstance(members[o].uid)) {
          var mrkr = markers[o];
          map.removeLayer(mrkr);
          //removeFromLayer(o);
          delete members[o];
          delete markers[o];
        }
      }
    }
    if (massCreate) {
      let stringified = JSON.stringify(massRequest);
      app.massMarkerCreation(stringified);
      //massRequest = [];
    }
  }
  isMarkersBusy = false;
  if (isStopped == true) {
    // DSMapClear();
  }
}
function setSolitaryMode() {
  solitaryModeOn = true;
  DSSetMapCenterZoom(0.0, 0.0, 14, false);

  app.getSolitaryMapLocation();
  solitaryUpdater = setInterval(function () {
    app.getSolitaryMapLocation();
  }, 3000);
}
function setSolitaryLocation(latitude, longitude) {
  var mrkr;
  try {
    if (solitaryLoc[0] != latitude || solitaryLoc[1] != longitude) {
      let date = new Date();
      DSNewMarker(
        "id_solitary",
        new L.LatLng(latitude, longitude),
        { icon: car, rotationAngle: 90, opacity: 1 },
        "user",
        "solitaryWolf",
        "#004d40",
        "arrow"
      );

      mrkr = markers["id_solitary"];
      var bearing = getBearing(
        mrkr.getLatLng().lat,
        latitude,
        mrkr.getLatLng().lng,
        longitude
      );
      var oldlat = solitaryLoc[0];
      var oldlng = solitaryLoc[1];
      var dist = distance(oldlat, oldlng, latitude, longitude);
      if (solitaryLoc[0] == 0 && solitaryLoc[1] == 0) {
        console.log("force center zoom: " + latitude + ", " + longitude);
        solitaryLoc[0] = latitude;
        solitaryLoc[1] = longitude;
        solitaryLoc[2] = 0;
        DSSetMapCenterZoom(latitude, longitude, 14, false);
      } else {
        if (map.getZoom() <= 1) {
          DSSetMapCenterZoom(latitude, longitude, 14, false);
        }
        console.log(
          "Solitary mode location received: " +
            latitude +
            ", " +
            longitude +
            ", " +
            bearing
        );
        solitaryLoc[0] = latitude;
        solitaryLoc[1] = longitude;
        if (typeof mrkr === "undefined") {
          mrkr = markers["id_solitary"];
        }
        if (dist < 1000) {
          var bearing = getBearing(
            mrkr.getLatLng().lat,
            latitude,
            mrkr.getLatLng().lng,
            longitude
          );
          smoothMove(
            mrkr.getLatLng(),
            new L.LatLng(latitude, longitude),
            solitaryLoc[2],
            bearing,
            date.getTime(),
            3000,
            mrkr,
            "id_solitary"
          );
          solitaryLoc[2] = bearing;
        } else {
          mrkr.setLatLng(new L.LatLng(latitude, longitude));
        }
        if (typeof mrkr === "undefined") {
          mrkr = markers["id_solitary"];
        }
        var bearing = getBearing(
          mrkr.getLatLng().lat,
          latitude,
          mrkr.getLatLng().lng,
          longitude
        );
        mrkr.setRotationAngle(bearing);
        solitaryLoc[2] = bearing;
      }
    }
  } catch (err) {
    console.log(`runtime error: ${err}.`);
  }
}

function isExistentMember(uid) {
  if (members["id_" + uid]) {
    return true;
  } else {
    return false;
  }
}
function getMemberInstance(uid) {
  if (members["id_" + uid]) {
    return members["id_" + uid];
  } else {
    return false;
  }
}
function saveMemberInstance(uid, member) {
  if (members["id_" + uid]) {
    members["id_" + uid] = member;
  }
}
function getResultInstance(uid) {
  if (lastResult["id_" + uid]) {
    return lastResult["id_" + uid];
  } else {
    return false;
  }
}
function getMembers(updateImmediate) {
  if (
    typeof gid != "undefined" &&
    gid != "unset" &&
    gid != null &&
    gid != "null"
  ) {
    if (isMarkersBusy == false) {
      xhr("getOnlineGroupBuddies", gid, function (cbdata) {
        var data = JSON.parse(cbdata);
        if (typeof data.result != "undefined" && data.result == "false") {
          if (data.msg == "ACCESS_DENIED") {
            app.groupDenied();
          }
        }
        for (var key in lastResult) {
          delete lastResult[key];
        }
        $.each(data.groups, function (i, item) {
          if (typeof item == "undefined" || item != null) {
            lastResult["id_" + item.uid] = item;
          }
        });
        updated = true;
        if (updateImmediate == true) {
          updateMarkers(true);
        }
        ////console.log("saving gdata @ " + gid);
        var storeObj = JSON.stringify(lastResult);
        ////console.log(JSON.stringify(lastResult));
        storage.setItem(gid, storeObj);
        if (isFollowing == true && !lastResult[selectedMarker]) {
          app.userPickupFail();
          DSStopFollow();
        }
      });
    }
  }
}
function getMapType() {
  xhr("getMapType", "none", function (cbdata) {
    var data = JSON.parse(cbdata);
    switch (data.type) {
      case "raster":
        addRasterLayer();
        break;
      case "vector":
        addVectorLayer();
        break;
      default:
        addRasterLayer();
    }
  });
}
function DSNewAlertMarker(alert) {
  console.log(alert);
  let alertIcon = new L.Icon({
    iconUrl: alert.marker,
    iconSize: [32, 37],
    iconAnchor: [0, 37],
  });

  var alertMarker = new L.Marker(
    new L.LatLng(alert.location.coordinates[0], alert.location.coordinates[1]),
    {
      icon: alertIcon,
      opacity: 0.0,
    }
  );
  alertMarker.on("click", function (data) {
    app.alertClick(alert._id);
  });
  return alertMarker;
}
function alertsUpdate(dt) {
  clearAlerts();
  let json = JSON.parse(dt);
  console.log(json.data.length);
  if (
    typeof json !== "undefined" &&
    json.data !== "undefiend" &&
    json.data.length > 0
  ) {
    for (let i = 0; i < json.data.length - 1; i++) {
      alerts[json.data[i]._id] = DSNewAlertMarker(json.data[i]);
      map.addLayer(alerts[json.data[i]._id]);
      DSFadeEffect(alerts[json.data[i]._id], 0.0, 1, 200);
    }
  }
}
function getTopRankedAlerts() {
  xhr("getTopRankedAlerts", "none", alertsUpdate);
}
function getPOIs() {
  if (isPOIEnabled == true) {
    xhr("GetNearPOI", gid, POIUpdate);
  }
}
function getObjects() {
  var mapCenter = map.getCenter();
  var mapZoom = map.getZoom();
  if (
    mapCenter.lng != lastgetobjectslng ||
    mapCenter.lat != lastgetobjectslat ||
    resumed
  ) {
    resumed = false;
    lastgetobjectslat = mapCenter.lat;
    lastgetobjectslng = mapCenter.lng;
    var req = {
      zoom: mapZoom,
      lat: mapCenter.lat,
      lng: mapCenter.lng,
    };
    xhr("GetObjects", JSON.stringify(req), ObjectsUpdate);
  }
}
function getPOIsON() {
  if (isPOIEnabled == true) {
    var mapCenter = map.getCenter();
    if (mapCenter.lng != lastgetpoionlng || mapCenter.lat != lastgetpoionlat) {
      lastgetpoionlat = mapCenter.lat;
      lastgetpoionlng = mapCenter.lng;
      var req = {
        gid: gid,
        lat: mapCenter.lat,
        lng: mapCenter.lng,
      };
      xhr("GetPOIOn", JSON.stringify(req), POIUpdate);
    }
  }
  if (isPOIEnabled == false) {
    clearPOIs();
  }
  if (isStopped == true) {
    // DSMapClear();
  }
}
function processShape(object) {
  var container = [];
  if (object.type == "shape" && typeof object.shapeProps != "undefined") {
    if (
      typeof object.iconUrl != "undefined" ||
      typeof object.iconUrlWeb != "undefined"
    ) {
      var iconsize;
      if (typeof object.iconSize.sizesWeb != "undefined") {
        iconsize = object.iconSize.sizesWeb;
      } else if (
        typeof object.iconSize.sizesWeb == "undefined" &&
        typeof object.iconSize.sizes != "undefined"
      ) {
        iconsize = object.iconSize.sizes;
      }
      var iconurl;
      if (typeof object.iconUrlWeb != "undefined") {
        iconurl = object.iconUrlWeb;
      } else if (
        typeof object.iconUrlWeb == "undefined" &&
        typeof object.iconUrl != "undefined"
      ) {
        iconurl = object.iconUrl;
      }
      var symbolIcon = new L.Icon({
        iconUrl: iconurl,
        iconSize: iconsize,
        iconAnchor: object.iconSize.anchor,
      });

      var symbolMarker = new L.Marker(object.latLng, {
        icon: symbolIcon,
        opacity: 0.0,
      });
      if (object.clickable == "true") {
        symbolMarker.on("click", function (data) {
          app.objectClick(JSON.stringify(object));
        });
      }
      container.push(symbolMarker);
    }
    switch (object.shapeProps.type) {
      case "polyline":
        container.push(
          L.polyline(object.shapeProps.data, object.shapeProps.options).on(
            "click",
            function () {
              if (object.clickable == "true") {
                app.objectClick(JSON.stringify(object));
              }
            }
          )
        );
        break;
      case "polygon":
        container.push(
          L.polygon(object.shapeProps.data, object.shapeProps.options).on(
            "click",
            function () {
              if (object.clickable == "true") {
                app.objectClick(JSON.stringify(object));
              }
            }
          )
        );
        break;
      case "rectangle":
        container.push(
          L.rectangle(object.shapeProps.data, object.shapeProps.options).on(
            "click",
            function () {
              if (object.clickable == "true") {
                app.objectClick(JSON.stringify(object));
              }
            }
          )
        );
        break;
      case "circle":
        container.push(
          L.circle(object.shapeProps.data, object.shapeProps.options).on(
            "click",
            function () {
              if (object.clickable == "true") {
                app.objectClick(JSON.stringify(object));
              }
            }
          )
        );
        break;
    }
    return container;
  }
}
function addDemoObject(latitude, longitude) {
  /*let demo = getDemoObject(latitude, longitude);
  let demoSymbol = processSymbol(demo);
  addObjToMap({ symbol: demoSymbol });*/
  let obj = [];
  obj.push(getDemoObject(latitude, longitude));
  ObjectsUpdate(JSON.stringify(obj));
  checkVisibility();
}
function getDemoObject(latitude, longitude) {
  return {
    UIAddr: "Seu endereço aparecerá aqui",
    id: "ANUNCIO_TESTE",
    type: "symbol",
    latLng: [latitude, longitude],
    iconUrl: "file:///android_asset/DSMap/poi_exemplo.svg",
    iconSize: {
      type: "dp",
      sizesWeb: [69, 49],
      sizes: [69, 49],
    },
    clickable: "true",
    title: "SEU NEGÓCIO AQUI",
    site: "mailto:comercial@drivesocial.io",
    description: "Aqui fica uma breve descrição sobre seu negócio.",
    address: "Seu endereço aqui",
    navegable: "true",
    bannerUrl: "file:///android_asset/DSMap/banner_exemplo.png",
    bannerSize: { type: "dp", width: 380, height: 130 },
  };
}
function processSymbol(object) {
  if (
    object.type == "symbol" &&
    typeof object.iconUrl != "undefined" &&
    typeof object.iconSize != "undefined"
  ) {
    var iconsize;
    if (typeof object.iconSize.sizesWeb != "undefined") {
      iconsize = object.iconSize.sizesWeb;
    } else if (
      typeof object.iconSize.sizesWeb == "undefined" &&
      typeof object.iconSize.sizes != "undefined"
    ) {
      iconsize = object.iconSize.sizes;
    }
    var iconurl;
    if (typeof object.iconUrlWeb != "undefined") {
      iconurl = object.iconUrlWeb;
    } else if (
      typeof object.iconUrlWeb == "undefined" &&
      typeof object.iconUrl != "undefined"
    ) {
      iconurl = object.iconUrl;
    }
    var symbolIcon = new L.Icon({
      iconUrl: iconurl,
      iconSize: iconsize,
      iconAnchor: object.iconSize.anchor,
    });
    var symbolMarker = new L.Marker(object.latLng, {
      icon: symbolIcon,
      opacity: 0.0,
    });
    if (object.clickable == "true") {
      symbolMarker.on("click", function (data) {
        app.objectClick(JSON.stringify(object));
      });
    }
    return symbolMarker;
  }
}
function hideObjOnMap(key, obj) {
  if (objectsLayer[key]) {
    if (typeof obj.shape != "undefined") {
      var shape = obj.shape;
      if (shape.length > 1) {
        shape[0].setOpacity(0);
        map.removeLayer(shape[1]);
      } else if (shape.length == 1) {
        map.removeLayer(shape[0]);
      }
    }
    if (typeof obj.symbol != "undefined") {
      obj.symbol.setOpacity(0);
    }
    delete objectsLayer[key];
  }
}
function objFitsTheBound(obj) {
  if (typeof obj.shape != "undefined") {
    var shape = obj.shape;
    if (shape.length > 1) {
      if (map.getBounds().contains(shape[0].getLatLng())) {
        return true;
      } else {
        return false;
      }
    } else {
      return true;
    }
  }
  if (typeof obj.symbol != "undefined") {
    if (map.getBounds().contains(obj.symbol.getLatLng())) {
      return true;
    } else {
      return false;
    }
  }
}
function objViewMaint() {
  for (var i in objectViewCache) {
    if (Math.round(new Date().getTime() / 1000) - objectViewCache[i] >= 900) {
      delete objectViewCache[i];
    }
  }
}
function viewCallback(key) {
  var obj = getObjectById(key);
  if (typeof obj.viewUrlCallback != "undefined") {
    if (!objectViewCache[key]) {
      $.ajax({
        method: "GET",
        url: obj.viewUrlCallback,
        crossDomain: true,
        timeout: 2000,
        success: function () {
          objectViewCache[key] = Math.round(new Date().getTime() / 1000);
        },
      });
    }
  }
}
function showObjOnMap(key, obj) {
  if (!objectsLayer[key] && objFitsTheBound(obj)) {
    if (typeof obj.shape != "undefined") {
      var shape = obj.shape;
      if (shape.length > 1) {
        DSFadeEffect(shape[0], 0, 1.0, 1000, "show_" + key);
        //console.log("Added advanced shape (with icons)");
        map.addLayer(shape[1]);
        //console.log(shape[1]);
      } else if (shape.length == 1) {
        //console.log("Added common shape (no icons)");
        map.addLayer(shape[0]);
        //console.log(shape[0]);
      }
    }
    if (typeof obj.symbol != "undefined") {
      DSFadeEffect(obj.symbol, 0, 1.0, 1000, "show_" + key);
    }
    objectsLayer[key] = obj;
    viewCallback(key);
  }
}
function clearMapObjects() {
  for (var key in objects) {
    delObjFromMap(key, objects[key]);
  }
  for (var key in objectsLayer) {
    delete objectsLayer[key];
  }
}

function addObjToMap(obj) {
  if (typeof obj.shape != "undefined") {
    for (var i in obj.shape) {
      map.addLayer(obj.shape[i]);
    }
  }
  if (typeof obj.symbol != "undefined") {
    map.addLayer(obj.symbol);
  }
}
function delObjFromMap(key, obj) {
  if (typeof obj.shape != "undefined") {
    for (var i in obj.shape) {
      map.removeLayer(obj.shape[i]);
    }
    delete objects[key];
  }
  if (typeof obj.symbol != "undefined") {
    map.removeLayer(obj.symbol);
    delete objects[key];
  }
  if (objectsLayer[key]) {
    delete objectsLayer[key];
  }
}
function ObjectsUpdate(data) {
  //console.log(data);
  var objreturn = JSON.parse(data);
  objRepo = objreturn;
  for (var o in objreturn) {
    if (typeof objects[objreturn[o].id] != "undefined") {
      if (
        !getObjectById(objreturn[o].id) ||
        typeof getObjectById(objreturn[o].id) == "undefined"
      ) {
        delObjFromMap(objreturn[o].id, objects[objreturn[o].id]);
      }
    }
  }
  for (var i in objreturn) {
    var obj = objreturn[i];
    if (!objects[obj.id]) {
      if (typeof obj.latLng != "undefined" && typeof obj.type != "undefined") {
        switch (obj.type) {
          case "symbol":
            var dt = processSymbol(obj);
            objects[obj.id] = { symbol: dt };
            break;
          case "shape":
            var dt = processShape(obj);
            objects[obj.id] = { shape: dt };
            break;
          default:
          //console.log('Unknown object type ' + obj.type + ', skipping...');
        }
        addObjToMap(objects[obj.id]);
      } else {
        //console.log("Ignoring object " + obj.id + " due to invalid LatLng or Type property");
      }
    }
  }
}
function POIUpdate(poireturn) {
  if (isPOIEnabled == true) {
    var typeIcon = "";
    var POIs = JSON.parse(poireturn);
    var data = POIs.POI;
    for (var key in poi) {
      if (!data[key.split("_")[1]]) {
        if (!map.getBounds().contains(poi[key].getLatLng())) {
          removePOI(key);
        }
      }
    }
    for (var key in data) {
      ////console.log(key);
      if (!poi["poi_" + data[key].pid]) {
        typeIcon = "file:///android_asset/DSMap/POI/" + data[key].type + ".png";
        ////console.log(data[key].pid + ": spawning POI (type: " + data[key].type + ", iconURL: " + typeIcon + ")");
        var POIicon = new L.Icon({
          iconUrl: typeIcon,
          iconSize: [14, 14],
        });
        DSNewPOI(
          "poi_" + data[key].pid,
          new L.LatLng(data[key].lat, data[key].lng),
          POIicon
        );
      }
    }
  } else {
    clearPOIs();
  }
}
function DSNewPOI(POILabel, LatLng, IconObj) {
  if (!poi[POILabel]) {
    poi[POILabel] = new L.Marker(LatLng, {
      icon: IconObj,
      opacity: 0.0,
    });
    poi[POILabel].setOpacity(0);
    // map.addLayer(poi[POILabel]);
    poi[POILabel].on("click", function (pmarker) {
      isPOISelected = true;
      var marker = poi[POILabel];
      var latLng = marker.getLatLng();
      app.POIMarkerClicked(POILabel, latLng.lat, latLng.lng);
      //DSMapFlyTo(latLng.lat, latLng.lng, 17, 2);
    });
    try {
      if (map.getBounds().contains(LatLng)) {
        map.addLayer(poi[POILabel]);
      }
    } catch (err) {
      //console.log("Ignoring map bounds due to error: " + err);
      map.addLayer(poi[POILabel]);
    }
    DSFadeEffect(poi[POILabel], 0.0, 1.0, 1000);
  }
}
function DSFadeEffect(marker, start, end, duration, key, callback) {
  if (
    marker.options.opacity != end &&
    typeof fadeWorking[key] !== "undefined" &&
    fadeWorking[key] !== true
  ) {
    fadeWorking[key] = true;
    marker.setOpacity(start);
    var current = start;
    if (markers.length <= 60) {
      var fadeInRender = new Handler();
      var starttime = new Date().getTime();
      fadeInRender.postDelayed(function () {
        function run() {
          var nowtime = new Date();
          var elapsed = nowtime.getTime() - starttime;
          let t = elapsed / duration;
          current = t * end + (1 - t) * start;
          marker.setOpacity(t);
          if (t < 1) {
            fadeInRender.postDelayed(run, 10);
          } else {
            delete fadeWorking[key];
            if (typeof callback != "undefined") {
              if (typeof key != "undefined" && key != null) {
                callback(key);
              } else {
                callback(marker);
              }
            }
          }
        }
        run();
      }, 1);
    } else {
      marker.setOpacity(end);
      delete fadeWorking[key];
      if (typeof callback != "undefined") {
        if (typeof key != "undefined" && key != null) {
          callback(key);
        } else {
          callback(marker);
        }
      }
    }
  } else {
    marker.setOpacity(end);
    if (typeof callback != "undefined") {
      if (typeof key != "undefined" && key != null) {
        callback(key);
      } else {
        callback(marker);
      }
    }
  }
}
function DSGetPOILatLng(pid) {
  ////console.log("Requesting LatLng from POI: " + pid);
  if (poi[pid]) {
    var latLng = poi[pid].getLatLng();
    app.getPOILatLngCallback(latLng.lat, latLng.lng);
  }
}
function clearZones() {
  for (var key in zones) {
    map.removeLayer(zones[key]);
    map.removeLayer(zonesbadges[key]);
    delete zones[key];
    delete zonesbadges[key];
  }
}
function getCriticalZones() {
  xhr("getCriticalZones", "none", function (dzones) {
    clearZones();
    if (criticalZonesEnabled == true) {
      var z = JSON.parse(dzones);
      if (z.result == "true" && z.code == "ok") {
        var data = z.zones;
        for (var key in data) {
          var item = data[key];
          switch (item.level) {
            case "1":
              var color = "#ff944d";
              var alpha = 0.1;
              break;
            case "2":
              var color = "#ff8533";
              var alpha = 0.2;
              break;
            case "3":
              var color = "#ff751a";
              var alpha = 0.3;
              break;
            case "4":
              var color = "#ff6600";
              var alpha = 0.4;
              break;
            case "5":
              var color = "#e65c00";
              var alpha = 0.5;
              break;
          }

          var circle = new L.circle(new L.LatLng(item.lat, item.lng), {
            radius: "1180",
            color: "#ff751a",
            weight: 0,
            fillColor: color,
            fillOpacity: alpha,
          });
          czLayer.addLayer(circle);
          /* map.addLayer(circle);
                        circle.getElement().id="zone_" + item.heatId;
                        circle.getElement.className += "zoneblur"; */

          var badgeIcon = new L.Icon({
            iconUrl: "file:///android_asset/DSMap/CZ/L" + item.level + ".png",
            iconSize: [30, 19],
          });
          zonesbadges["id_" + item.heatId] = new L.Marker(
            new L.LatLng(item.lat, item.lng),
            { icon: badgeIcon }
          );
          map.addLayer(zonesbadges["id_" + item.heatId]);
          zones["id_" + item.heatId] = circle;
        }
      }
    } else {
      clearZones();
    }
    if (isStopped == true) {
      //DSMapClear();
    }
  });
}
function getMembersCb(cbdata) {
  var data = JSON.parse(cbdata);
  for (var key in lastResult) {
    delete lastResult[key];
  }
  $.each(data.groups, function (i, item) {
    lastResult["id_" + item.uid] = item;
  });
  updated = true;
}

function toRadians(degrees) {
  return (degrees * Math.PI) / 180;
}
function toDegrees(radians) {
  return (radians * 180) / Math.PI;
}
function getBearing(lat1, lat2, lon1, lon2) {
  lat1 = toRadians(lat1);
  lat2 = toRadians(lat2);
  lon1 = toRadians(lon1);
  lon2 = toRadians(lon2);

  var y = Math.sin(lon2 - lon1) * Math.cos(lat2);
  var x =
    Math.cos(lat1) * Math.sin(lat2) -
    Math.sin(lat1) * Math.cos(lat2) * Math.cos(lon2 - lon1);

  var bearing = Math.atan2(y, x);
  bearing = toDegrees(bearing);
  return (bearing + 360) % 360;
}

function smoothMove(
  fromLatLng,
  toLatLng,
  fromAngle,
  toAngle,
  starttime,
  millis,
  marker,
  id
) {
  if (marker.options.opacity > 0) {
    let moverId = Math.floor(Math.random() * 99999) + 10001;
    smoothMovers[moverId] = new Handler();
    var fromLat = fromLatLng.lat;
    var fromLng = fromLatLng.lng;
    var toLat = toLatLng.lat;
    var toLng = toLatLng.lng;
    var t;
    var lng;
    var lat;
    var angle;
    var animId;
    var lastLat, lastLng;
    if (toAngle == 0 || typeof toAngle == "undefined") {
      toAngle = getBearing(fromLat, toLat, fromLng, toLng);
    }
    if (fromAngle < toAngle && fromAngle < 180 && toAngle > 180) {
      toAngle = toAngle - 360;
    }
    if (fromAngle < toAngle && fromAngle > 180 && toAngle < 180) {
      fromAngle = fromAngle - 360;
    }
    smoothMovers[moverId].requestFrame(function () {
      function run() {
        var nowtime = new Date();
        var elapsed = nowtime.getTime() - starttime;
        t = elapsed / millis;
        if (typeof lastLat == "undefined" || typeof lastLng == "undefined") {
          lastLat = lat;
          lastLng = lng;
        }

        lng = t * toLng + (1 - t) * fromLng;

        lat = t * toLat + (1 - t) * fromLat;

        angle = t * toAngle + (1 - t) * fromAngle;
        if (isMoving) {
          if (isFollowing) {
            marker.setRotationAngle(angle);
            marker.setLatLng(new L.LatLng(lat, lng));
          }
        } else {
          marker.setRotationAngle(angle);
          marker.setLatLng(new L.LatLng(lat, lng));
        }

        if (t < 1) {
          smoothMovers[moverId].requestFrame(run);
        }
      }
      run();
    });
  }
}
var osm;
var gl;
function addRasterLayer() {
  //console.log("Switching to Raster layer");
  //var dstiles='http://livemap-tiles4.waze.com/tiles/{z}/{x}/{y}.png';
  var dstiles =
    "https://server.drivesocial.io/dstiles/tile.php?s={s}&z={z}&x={x}&y={y}";
  //var dstiles='http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
  var osmAttrib =
    '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors';
  osm = new L.TileLayer(dstiles, {
    minZoom: 1,
    maxZoom: 19,
    attribution: osmAttrib,
    useCache: true,
  });

  map.addLayer(osm);

  /*membersUpdater = setInterval(function() { getMembers(); }, 3000);
    markersUpdater = setInterval(function() { updateMarkers(); }, 3200);*/
  /*if (typeof followHelper != 'undefined') {
        cancelInterval(followHelper);
    }*/
  addCanvasLayer();
  followHelper = setInterval(function () {
    follower();
  }, 3000);
}
function addCanvasLayer() {
  // canvasLayer = new L.canvasIconLayer({}).addTo(map);
}
function addVectorLayer() {
  //console.log("Switching to Vector layer");
  if (mapboxgl.supported() == true) {
    var gl = new L.mapboxGL({
      style: "https://server.drivesocial.io/config/tilegl.json",
      accessToken: "no-token",
      zoomControl: false,
      zoomSnap: 1,
    });
    vectorLayer = "remote";
    glbox = gl;
    map.addLayer(gl);
    /* if (typeof followHelper != 'undefined') {
        cancelInterval(followHelper);
    }*/
    addCanvasLayer();
    followHelper = setInterval(function () {
      follower();
    }, 3000);
  } else {
    console.log("WebGL NOT supported. Falling back to Raster layer");
    addRasterLayer();
  }
}
function setNightStyle() {
  if (isNightTheme == false) {
    document.getElementById("map").style.background = "#464644";
    if (vectorLayer == "local") {
      glbox._glMap.setStyle(
        "https://server.drivesocial.io/config/tilegl-night-localhost.json"
      );
      isNightTheme = true;
    } else if (vectorLayer == "remote") {
      glbox._glMap.setStyle(
        "https://server.drivesocial.io/config/tilegl-night.json"
      );
      isNightTheme = true;
    }
  }
}
function setDayStyle() {
  if (isNightTheme == true) {
    document.getElementById("map").style.background = "#E8E5D8";
    if (vectorLayer == "local") {
      glbox._glMap.setStyle(
        "https://server.drivesocial.io/config/tilegl-localhost.json"
      );
      isNightTheme = false;
    } else if (vectorLayer == "remote") {
      glbox._glMap.setStyle("https://server.drivesocial.io/config/tilegl.json");
      isNightTheme = false;
    }
  }
}
function addLocalVectorLayer() {
  //console.log("Switching to Vector layer");
  if (mapboxgl.supported() == true) {
    var gl = new L.mapboxGL({
      style: "https://server.drivesocial.io/config/tilegl-localhost.json",
      accessToken: "nop-tokenp",
      zoomControl: false,
      zoomSnap: 1,
      antialias: true,
    });
    vectorLayer = "local";
    glbox = gl;
    map.addLayer(gl);

    /* if (typeof followHelper != 'undefined') {
        cancelInterval(followHelper);
    }*/
    addCanvasLayer();
    followHelper = setInterval(function () {
      follower();
    }, 3000);
  } else {
    console.log("WebGL NOT supported. Falling back to Raster layer");
    addRasterLayer();
  }
}
setInterval(function () {
  objViewMaint;
}, 120000);
/*window.onload = () => {
  setTimeout(() => {
    console.log("DSMapCore loaded. Sending callbacks...");
    app.dispatchMapReady();
  }, 500);
};*/
window.onload = function () {
  if (!ready) {
    ready = true;
    setTimeout(function () {
      console.log("DSMapCore loaded. Sending callbacks...");
      app.dispatchMapReady();
    }, 500);
  }
};
var glbox;
