function Handler() {}

var id = null;
var state = "sleep";

Handler.prototype.post = function (cbFunc) {
  if (typeof cbFunc === "function") {
    this.state = "ready";
    //console.log("Handler: Executing Handler without a delay");
    var execute = function () {
      this.state = "work";
      // console.log("Handler: Executing Handler post now...");
      cbFunc();
      this.state = "sleep";
      // console.log("Handler: Execution done.")
    };
  }
};

Handler.prototype.requestFrame = function (cbFunc) {
  if (typeof cbFunc === "function") {
    this.state = "ready";
    var execute = function () {
      this.state = "work";
      cbFunc();
      this.state = "sleep";
    };
    this.state = "sched";
    this.id = window.requestAnimationFrame(execute);
  }
};

Handler.prototype.postDelayed = function (cbFunc, millis) {
  if (typeof cbFunc === "function") {
    this.state = "ready";
    //console.log("Handler: post scheduled to " + millis + " milliseconds ahead.");
    var execute = function () {
      this.state = "work";
      //console.log("Handler: Executing Handler post now...");
      cbFunc();
      this.state = "sleep";
      // console.log("Handler: Execution done.")
    };
    this.state = "sched";
    this.id = setTimeout(execute, millis);
  }
};

Handler.prototype.cancel = function () {
  clearTimeout(id);
  this.state = "cancelled";
};
/*
class Handler {
    constructor() {
        this.id = null;
    }
    post(cbFunc) {
        if (typeof cbFunc === 'function') {
            //console.log("Handler: Executing Handler without a delay");
            var execute = function() { 
               // console.log("Handler: Executing Handler post now...");
                cbFunc(); 
               // console.log("Handler: Execution done.")                
            }
        }
    }
    postDelayed(cbFunc, millis) {
        if (typeof cbFunc === 'function') {
            //console.log("Handler: post scheduled to " + millis + " milliseconds ahead.");
            var execute = function() { 
               //console.log("Handler: Executing Handler post now...");
                cbFunc(); 
               // console.log("Handler: Execution done.")                
            }
            this.id = setTimeout(execute, millis);
            
        }
    }
    cancel() {
        clearTimeout(this.id);
    }

}*/
